# wet/plugs/desk.py
#
#

""" show version. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from wet.kernel import kernel, plugs, cfg
from wet import __version__

import wet

## CMNDS

def desk_copyright(event): event.reply(__copyright__)

kernel.register('desk.copyright', desk_copyright)

def desk_version(event): event.reply("WET #%s - email analyse software " % __version__)

kernel.register("desk.version", desk_version)

def desk_test(event): event.reply("hello %s" % event.origin)

kernel.register("desk.test", desk_test)

def desk_ls(event):
    if not event.parsed.rest:
       result = set([x.split(".")[-1] for x in kernel.names()])
       event.reply(", ".join(sorted(result)))
       return
    name = ""
    keys = kernel.search(event.parsed.rest)
    if keys: event.reply(", ".join(keys))
 
kernel.register("desk.ls", desk_ls)

def desk_plugs(event):
    rest = event.parsed.rest
    if not rest:
       result = set(plugs.names())
       event.reply(", ".join(sorted([".".join(x.split(".")[1:]) for x in result])))
       return
    name = ""
    keys = plugs.search(rest)
    event.reply(", ".join([".".join(x.split(".")[1:]) for x in keys]))
 
kernel.register("desk.plugs", desk_plugs)

def desk_cfg(event):
    obj = cfg
    if event.parsed.args:
        ctype = event.parsed.args[0]
        obj = kernel.last("cfg", ctype)
        if not obj: obj = getattr(wet.cfg, "cfg_%s" % ctype, None)
    try: 
        key = event.parsed.args[1]
        value = event.parsed.args[2]
        if key in obj: obj[key] = value ; obj.prefix = "cfg" ; obj.sync()
    except IndexError: pass
    if obj: event.reply("\n".join(obj.show()))

kernel.register("desk.cfg", desk_cfg)

def desk_kernel(event): event.reply(kernel.pretty())

kernel.register("desk.kernel", desk_kernel)

def desk_where(event):
    name = event.parsed.rest
    cmnds = kernel.search(name)
    result = []
    for name in cmnds: result.extend([x.plugname for x in kernel.get(name)])
    if result: event.reply(", ".join(set(result)))

kernel.register("desk.where", desk_where)

